<?php

$preset = 'Shanghai';
$base = 'http://' . $_SERVER['HTTP_HOST'] . dirname($_SERVER['SCRIPT_NAME']);

session_name('SID');
session_start();
$SID = 'SID=' . session_id();

if (!$_REQUEST['SID'])
	die ($SID);
if (isset($_SERVER['PATH_INFO']) && $_SERVER['PATH_INFO'] == '/SID')
	die ($SID);

if (!isset($_SESSION['count']))
	$_SESSION['count'] = 1;

if (!isset($_SESSION['files']) || !count($_SESSION['files'])) {
	$prefix = $base . '/' . $preset;
	$handle = opendir($preset);
	while (false != ( $file = readdir($handle))) {
		$path_parts = pathinfo($file);
		if (strtolower($path_parts['extension']) != 'jpg')
	                	continue;
		$_SESSION['files'][] = $prefix . '/' . $file;
	}
	# reset counter
	$_SESSION['count'] = 1;
}

# aktuelle Bilderliste
if (isset($_SERVER['PATH_INFO']) && $_SERVER['PATH_INFO'] == '/LST')
	die (var_dump($_SESSION['files']));

# aktuelles, dh. voriges Bild
if (isset($_SERVER['PATH_INFO']) && $_SERVER['PATH_INFO'] == '/IMG')
	die('<img src="'
		. $_SESSION['files'][$_SESSION['count'] - 2]
		. '" title="'
		. $_SESSION['files'][$_SESSION['count'] - 2]
		. '"/>');

# Info zum aktuellen, dh. vorigen Bild
if (isset($_SERVER['PATH_INFO']) && $_SERVER['PATH_INFO'] == '/NFO')
	die($_SESSION['count'] - 1 . "/"
		. count($_SESSION['files']) . " "
		. $_SESSION['files'][$_SESSION['count'] - 2]);

# http head request
function headrequest($host, $port, $path) {
	$timeout = 5;

	$fp = @fsockopen($host, $port, $errno, $errstr, $timeout);
	if (!$fp) return '';

	fwrite($fp, "HEAD $path HTTP/1.1\r\n");
	fwrite($fp, "Host: $host\r\n");
	fwrite($fp, "Connection: Close\r\n");
	fwrite($fp, "\r\n");

	$buffer = '';
	socket_set_timeout($fp, $timeout);
	while(!feof($fp))
		$buffer .= fgets($fp, 128);
	fclose($fp);
	return $buffer;
}

# URL prüfen, Ziel
function hastarget($link) {
	$url = parse_url($link);
	if (!$url)
		return false();
	if (!isset($url['host']))
		return false();
	if (!isset($url['scheme']))
		return false();
	if (strtolower($url['scheme']) != 'http')
		return false();
	if (!isset($url['path']))
		return false();
	if (!isset($url['port']))
		$url['port'] = 80;
	$parts = explode('/', $url['path']);
	for ($i = 0; $i < count($parts); $i++)
		$parts[$i] = rawurlencode($parts[$i]);
	$url['path'] = implode('/', $parts);
	if (isset($url['query']))
		$url['path'] .= '?' . $url['query'];
	$header = headrequest($url['host'], $url['port'], $url['path']);
	return explode("\r\n", $header);
}

# Ziel vorhanden?
function checklink() {
	if (!isset($_SESSION['files'][$_SESSION['count'] - 1])) {
		shuffle ($_SESSION['files']);
		$_SESSION['count'] = 1;
	}
	$file = $_SESSION['files'][$_SESSION['count'] - 1];

	$head = hastarget($file);
	$ISOK = '/^HTTP.+ 200 OK$/';
	$HTML = '/^Content-Type: text\/html$/';
	if (!$head || !count(preg_grep($ISOK, $head))
		|| count(preg_grep($HTML, $head))) {
		unset($_SESSION['files'][$_SESSION['count'] - 1]);
		# neu indizieren
		$_SESSION['files'] = array_merge($_SESSION['files']);
		# Rekursion
		list($file, $head) = checklink();
	}
	return array($file, $head);
}

list($file, $head) = checklink();

$type = implode('', preg_grep('/^Content-Type:/', $head));

# weiter...
$_SESSION['count'] ++;

header($type);
readfile($file);

?>
